//$(function() {

	//==========================
	//LOGIN
	//==========================
	$(document).on("vclick", "#btnlogin", function (event) {
		event.preventDefault();
		
		$('#loginnotifymsg').html('');
		var loginemail = $('#loginemail').val();
		var loginpassword = $('#loginpassword').val();
		var serviceskey = ''; // required field that is used for automatic login
		
		var mysite = window.localStorage.getItem('mysite');
		var mystore = window.localStorage.getItem('mystore');
		
		var request = $.ajax({
			type: "POST",
			url: "http://www.grocery-bag.mobi/services/userlogin.v2.php",
			data: { groupid: groupid, email:loginemail , pass:loginpassword, serviceskey:serviceskey, mysite:mysite, mystore: mystore }, 
			dataType: "json"
		});
		
		request.done(function(data) {			
			
			if (data.loginstatus == 'fail') {
				$('#loginnotifymsg').html(data.notifymsg);
			
			} else if (data.loginstatus == 'success') {
			
				window.localStorage.setItem('userid', data.id);
				window.localStorage.setItem('mysite', data.mysite);
				window.localStorage.setItem('mystore', data.mystore);
				window.localStorage.setItem('serviceskey', data.serviceskey);
				window.localStorage.setItem('store_lat', data.store_lat);
				window.localStorage.setItem('store_long', data.store_long);
				window.localStorage.setItem('store_adtype_txt', data.store_adtype_txt);
				window.localStorage.setItem('store_adtype_jpg', data.store_adtype_jpg);
				window.localStorage.setItem('store_adtype_pdf', data.store_adtype_pdf);
				window.localStorage.setItem('accountstatus', 'active');
				
				$('#loginemail').val('');
				$('#loginpassword').val('');
				$('#loginnotifymsg').empty();
				
				if (window.localStorage.getItem('mystore') == 0) {
					startgeolocation();
				} else {
					$.mobile.pageContainer.pagecontainer( "change", "#home", { transition: "slide" } );
				}
				
			} else {
				//alert( "Login Failed Due To A Network Error.");
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					'Login Failed Due To A Network Error.',  	// message
					alertDismissed,         // callback
					'Alert',							// title
					'OK'                  						// buttonName
				);
			
			}
			
		});
 
		request.fail(function(jqXHR, textStatus) {
			//alert( 'Login Failed Due To A Network Error.'+textStatus);
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				'Login Failed Due To A Network Error. '+textStatus, 
				alertDismissed,         // callback
				'Login Failure', 
				'OK'
			);
			
		});
		
	});
	
	//==========================
	//JOIN US
	//==========================
	
	$(document).on("vclick", "#btnjoinus", function (event) {
	
		$('#joinusnotifymsg').html('');
		$('#joinusform label').removeClass('notify');
		
		var mysite = window.localStorage.getItem('mysite');
		var mystore = window.localStorage.getItem('mystore');
		
		var isErrorFree = true;
		
		var data_save = $("#joinusform").serializeArray();
		data_save.push({ 'name' : 'groupid', value: groupid });
		data_save.push({ 'name' : 'mysite', value: mysite });
		data_save.push({ 'name' : 'mystore', value: mystore });
		data_save.push({ 'name' : 'accesskey', value: '8B0R_Y3CQVsvjaWY3z-rAgMEg2wF_WvNqYD-PqEtx2zN3qG4kRtf-dEb54UHw6ovRY' });
		
		jQuery.each(data_save, function(i, field){
		
			var val = $.trim(field.value);
			if ( val.length == 0 ){
				isErrorFree = false;
				$('label[for="joinus'+field.name+'"]').addClass('notify');
			}
		
		});
		
		if (isErrorFree) {
		
			var request = $.ajax({
				type: "POST",
				url: "http://www.grocery-bag.mobi/services/joinusregistration.initializeuserinfo.v2.php",
				data: data_save, 
				dataType: "json"
			});
			
			request.done(function(data) {			
				
				if (data.response == 'error') {
					$('#joinusnotifymsg').html(data.msg);
					//alert(data.msg);
				
					navigator.notification.vibrate(1000);
					navigator.notification.alert(
						data.msg, 
						alertDismissed,         // callback
						'Alert', 
						'OK'
					);
					
					
					$.each(data.errors, function(i, field){
						$('label[for="joinus'+field+'"]').addClass('notify');
						$('#joinus'+field).addClass('invalid');
					});
					
				} else if (data.response == 'error_emailexist') {
					
					$('#joinusnotifymsg').html(data.msg);
					//alert(data.msg);
					
					navigator.notification.vibrate(1000);
					navigator.notification.alert(
						data.msg, 
						alertDismissed,         // callback
						'Alert', 
						'OK'
					);
					
					
					$('label[for="joinusemail"]').addClass('notify');
					$('#joinusemail').addClass('invalid');
			
				} else if (data.response == 'success') {
				
					window.localStorage.setItem('userid', data.id);
					window.localStorage.setItem('serviceskey', data.serviceskey);
					window.localStorage.setItem('accountstatus', 'active');
					
					if (window.localStorage.getItem('mystore') == 0) {
						startgeolocation();
					} else {
						$.mobile.pageContainer.pagecontainer( "change", "#home", { transition: "slide" } );
					}
					
				} else if (data.response == 'error_internal') {
					//alert(data.msg);
					
					navigator.notification.vibrate(1000);
					navigator.notification.alert(
						data.msg, 
						alertDismissed,         // callback
						'Alert', 
						'OK'
					);
					
				
				} else {
					//alert( "Login Failed Due To A Network Error.");
					
					navigator.notification.vibrate(1000);
					navigator.notification.alert(
						'Login Failed Due To A Network Error.', 
						alertDismissed,         // callback
						'Alert', 
						'OK'
					);
					
				}
				
			});
	 
			request.fail(function(jqXHR, textStatus) {
				//alert( "Login Failed Due To A Network Error."+textStatus);
				
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
						'Login Failed Due To A Network Error. '+textStatus, 
						alertDismissed,         // callback
						'Alert', 
						'OK'
				);
				
			});

		} else {
			$('#joinusnotifymsg').html('Please make the following corrections.');
		}
		
	});
	
	//join us cleanup
	$(document).on("pagebeforehide", "#joinus", function () {
		
		$('#joinusnotifymsg').empty();
		$('#joinususername').val('');
		$('#joinusemail').val('');
		$('#joinuspassword').val('');
	
	});
	
	//==========================
	//GUEST ACCOUNT
	//==========================
	$(document).on("vclick", "#btnguestaccount", function (event) {
		event.preventDefault();
		window.localStorage.setItem('accountstatus', 'guest');
		startgeolocation();
	
	});
	
	function startgeolocation() {
		$.mobile.loading( "show", { textVisible: false });
		navigator.geolocation.getCurrentPosition(geo_success, geo_error);
	
	}
	
	function geo_success(position) {
		window.localStorage.setItem('userlat', position.coords.latitude);
		window.localStorage.setItem('userlng', position.coords.longitude);
		
		$.mobile.loading( "hide" );
		$.mobile.pageContainer.pagecontainer( "change", "#locationsselectstore", { transition: "slide" } );
		
	}
	
	function geo_error(err) {
		window.localStorage.setItem('userlat', 0);
		window.localStorage.setItem('userlng', 0);
	
		$.mobile.loading( "hide" );
		
		if (err.code == 1) {
			//error('The user denied the request for location information.')
		} else if (err.code == 2) {
			error('Your location information is unavailable.');
		} else if (err.code == 3) {
			error('The request to get your location timed out.');
		} else {
			error('An unknown error occurred while requesting your location.');
		}
		
		$.mobile.pageContainer.pagecontainer( "change", "#locations", { transition: "slide" } );

	}
	
	function error(msg) {
		
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
			msg,  					// message
			alertDismissed,         // callback
			'Alert',	// title
			'Done'                  // buttonName
		);
		
	}
	
//});




























