$(document).on("pagebeforeshow", "#grocerylist", function () {
	$('#grocerylistmsg').empty();
	$('#grocerylistlistview').empty();
	$('#grocerylistlistview').hide();
});
	
$(document).on("pageshow", "#grocerylist", function () {
	
	if (window.localStorage.getItem('userid') > 0 && window.localStorage.getItem('accountstatus') == 'active') {
	
		$('#scanbarcodebucket').show();
		$.mobile.loading( "show");
		
		var userid = window.localStorage.getItem('userid');
		var serviceskey = window.localStorage.getItem('serviceskey');
		
		var request = $.ajax({
			type: "POST",
			url: "http://www.grocery-bag.mobi/services/grocerylist.v2.php",
			data: { groupid: groupid, id: userid, serviceskey: serviceskey, accesskey: '68F8F-Ea-erv-Aq-yqSDPb3Ky-aJfbP-864'}, 
			dataType: "json"
		});
		
		request.done(function(data) {
		
			if (data.response == 'error') {
				//alert(data.msg);
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
						data.msg, 
						alertDismissed,         // callback
						'Alert', 
						'OK'
				);
				
			} else if (data.response == 'success' && data.msg) {
				//things like no items or item added/updated
				$('#grocerylistmsg').append('<h4 class="centertext">'+data.msg+'</h4>');
				
			} else if (data.response == 'success' && data.items) {
			
				var items = '';
				$.each(data.items, function(i, e) {
				
					items = items+'<li class="gl_itembucket" id="grocerylistli'+e.id+'">'+
									'<a href="#" class="checkboxeventbtn" data-itemid="'+e.id+'" data-checkboxstate="'+e.checkboxstate+'">'+
									
									'<img src="img/checkbox_'+e.checkboxstate+'.png">'+
									
									'<h2><span id="item'+e.id+'">'+e.item+'</span></h2>'+
									
									'<p><strong>'+
									'<span class="gl_itemqty" id="qty'+e.id+'">'+e.quantity+'</span>'+
									' X '+
									'<span class="gl_itemprice" id="price'+e.id+'">'+e.price+'</span>'+
									' = '+
									'<span id="itemtotal'+e.id+'">'+fmtPrice((e.quantity * e.price))+'</span>'+
									'</strong></p>'+
									
									'<p id="notes'+e.id+'">'+e.notes+'</p>'+
									'</a>'+
									
									'<a href="#" data-itemid="'+e.id+'" data-transition="slide" class="btneditgrocerylistitem">Item Details</a>'+ 
									'</li>';
				
				});
				
				$('#grocerylistlistview').append(items);
				$('#grocerylistlistview').listview( "refresh" );
				$('#grocerylistlistview').show();
				calculatePriceTotal();
			
			} else {
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					'A Network Error Has Occurred.', 
					alertDismissed,         // callback
					'Alert', 
					'OK'
				);
			
			}
			
			$.mobile.loading( "hide" );
		
		
		});
		
		request.fail(function(jqXHR, textStatus) {
			//alert( "Login Failed Due To A Network Error."+textStatus);
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				'Login Failed Due To A Network Error. '+textStatus, 
				alertDismissed,         // callback
				'Alert', 
				'OK'
			);
			
		});
	
	} else {
	
		//alert('Please sign in or join us to add items to your grocery list.');
		
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
			'Please sign in or join us to add items to your grocery list.',	// message
			alertDismissed,         // callback
			'Alert',		// title
			'Done'                  	// buttonName
		);
	
	}



});

/*BARCODE SCANNER*/

$( document ).on( "vclick", "#scanbarcode", function(event) {
	
	$('#scanbarcodebucket').hide();
	$('#grocerylistmsg').empty().append('<h4 class="centertext">Loading Scanner</h4>');
	
	cordova.plugins.barcodeScanner.scan(scannerSuccess, scannerFailure);

});

function scannerSuccess(result) {
	
	var serviceskey = window.localStorage.getItem('serviceskey');
	var userid = (window.localStorage.getItem('userid') !== null) ? window.localStorage.getItem('userid') : 0 ;
	
	var request = $.ajax({
			type: "POST",
			url: "http://www.grocery-bag.mobi/services/simpleUPC_lookup.v2.php",
			data: { id : userid, serviceskey: serviceskey, upc: result.text, accesskey: 'ncac-Epr-7t-Uxu-Mndieyg-u83B-UHVYt'}, 
			dataType: "json"
	});
		
	request.done(function(data) {
	
		if (data.response == 'success') {
		
			var item = '<li class="gl_itembucket" id="grocerylistli'+data.id+'">'+
									'<a href="#" class="checkboxeventbtn" data-itemid="'+data.id+'" data-checkboxstate="NO">'+
									'<img src="img/checkbox_NO.png">'+
									'<h2><span id="item'+data.id+'">'+data.item+'</span></h2>'+
									'<p><strong>'+
									'<span class="gl_itemqty" id="qty'+data.id+'">'+data.quantity+'</span>'+
									' X '+
									'<span class="gl_itemprice" id="price'+data.id+'">'+data.price+'</span>'+
									' = '+
									'<span id="itemtotal'+data.id+'">'+fmtPrice((data.quantity * data.price))+'</span>'+
									'</strong></p>'+
									'<p id="notes'+data.id+'">'+data.note+'</p>'+
									'</a>'+
									'<a href="#" data-itemid="'+data.id+'" data-transition="slide" class="btneditgrocerylistitem">Item Details</a>'+ 
									'</li>';
									
						
				$('#grocerylistlistview').prepend(item);
				$('#grocerylistlistview').listview( "refresh" ).show();
				$('#scanbarcodebucket').show();
						
			
		} else {
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				'Sorry, the requested product could not be found in our system.', 
				alertDismissed, 
				'Alert', 
				'OK'
			);
			
		}
			
	});
		
	request.fail(function(jqXHR, textStatus) {
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
			'Sorry, a network error has occurred please try again.', 
			alertDismissed, 
			'Alert', 
				'OK'
		);
	});
	
	$('#scanbarcodebucket').show();
	$('#grocerylistmsg').empty();
	
}

function scannerFailure(message) {
	navigator.notification.vibrate(1000);
	navigator.notification.alert(
		"Scanning failed: " + message, 
		alertDismissed, 
		'Alert', 
		'OK'
	);
	
	$('#scanbarcodebucket').show();
	$('#grocerylistmsg').empty();
	
}


//CHECKBOX EVENTS
$( document ).on( "vclick", ".checkboxeventbtn", function(event) {
	event.preventDefault();
	
	var checkboxstate = '';
	var userid = (window.localStorage.getItem('userid') !== null) ? window.localStorage.getItem('userid') : 0 ;
	var itemid = $(this).jqmData('itemid');
	var thisobj = $(this);
	
	if ($(this).jqmData('checkboxstate') == 'NO') {
		checkboxstate = 'YES';
	} else {
		checkboxstate = 'NO';
	}
	
	var request = $.ajax({
		type: "POST",
		url: "http://www.grocery-bag.mobi/services/grocerylist_checkboxstate.v2.php",
		data: { groupid: groupid, id: userid, checkboxstate: checkboxstate, itemid: itemid, accesskey: 'HUCac-Epr-et-Uxu-TeCrE8RA8-r7P-EjAwAga'}, 
		dataType: "json"
	});
		
	request.done(function(data) {
			
		if (data.response == 'error') {
				//alert(data.msg);
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					data.msg, 
					alertDismissed,         // callback
					'Alert', 
					'OK'
				);
				
				
		} else if (data.response == 'success') {
			
			$('img', thisobj).attr('src', 'img/checkbox_'+checkboxstate+'.png');
			thisobj.jqmData('checkboxstate', checkboxstate);
				
		} else {
			//alert( "A Network Error Has Occurred.");
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				'A Network Error Has Occurred.', 
				alertDismissed,         // callback
				'Alert', 
				'OK'
			);
			
		}
			
	});

});

//setup item id and open page
$(document).on('vclick', '.btneditgrocerylistitem', function(event) {
	
	event.preventDefault();
	itemid = $(this).jqmData('itemid');
	
	$.mobile.pageContainer.pagecontainer( "change", "#grocerylistedit", { transition: "slide" } );

});

/*GROCERY LIST EDIT*/
$(document).on('pagebeforeshow', '#grocerylistedit', function(e, data){

	if (itemid > 0) {
	
		var item = $('#item'+itemid).html();
		var qty = $('#qty'+itemid).html();
		var price = $('#price'+itemid).html();
		var itemtotal = $('#itemtotal'+itemid).html();
		var notes = $('#notes'+itemid).html();
	
		$('#grocerylistinputitem').val(item);
		$('#grocerylistinputquantity').val(qty);
		$('#grocerylistinputnote').val(notes);
		$('#grocerylistinputprice').val(price);
		$('#grocerylistitemid').val(itemid);
		$('#grocerylistitemotal').html(itemtotal);
		$('#btnprocessgrocerylistitem').html('Update Item');
		$('#btngrocerylistremove').attr('data-itemid', itemid);
		$('#grocerylistremovebucket').show();
		
	}

});

$(document).on("pagebeforehide", "#grocerylistedit", function () {
	resetitemeditform();
});

//edit item process data
$( document ).on( "vclick", "#btnprocessgrocerylistitem", function() {

	$('#grocerylistitemnotifymsg').html('');
	$('#grocerylistitemfrm label').removeClass('notify');
	$('.grocerylistinput').removeClass('invalid');
	var userid = window.localStorage.getItem('userid');
	
	if (userid > 0) {
	
		$.mobile.loading( "show");
		
		var serviceskey = window.localStorage.getItem('serviceskey');
		var isErrorFree = true;
		
		var data_save = $("#grocerylistitemfrm").serializeArray();
		data_save.push({ 'name' : 'groupid', value: groupid });
		data_save.push({ 'name' : 'accesskey', value: 'duGu-SeChu-4werephu-fEq8p-Rubr' });
		data_save.push({ 'name' : 'userid', value: userid });
		data_save.push({ 'name' : 'serviceskey', value: serviceskey });
		
		jQuery.each(data_save, function(i, field){
		
			if (field.name !== 'grocerylistinputnote') {
				var val = $.trim(field.value);
				if ( val.length == 0 ){
					isErrorFree = false;
					$('label[for="'+field.name+'"]').addClass('notify');
					$('#'+field.name).addClass('invalid');
				}
			}
		
		});
		
		if (isErrorFree) {
		
			var request = $.ajax({
				type: "POST",
				url: "http://www.grocery-bag.mobi/services/grocerylistedititem.v2.php",
				data: data_save, 
				dataType: "json"
			});
		
			request.done(function(data) {
			
				$.mobile.loading( "hide" );
				//console.log(data);
			
				if (data.response == 'error') {
					//alert(data.msg);
					navigator.notification.vibrate(1000);
					navigator.notification.alert(
						data.msg, 
						alertDismissed,         // callback
						'Alert', 
						'OK'
					);
				
				} else if (data.response == 'success') {
				
					$.mobile.pageContainer.pagecontainer( "change", "#grocerylist", { reverse: true, transition: "slide" } );
					
				} else {
					//alert( "A Network Error Has Occurred.");
					navigator.notification.vibrate(1000);
					navigator.notification.alert(
						'A Network Error Has Occurred.', 
						alertDismissed,         // callback
						'Alert', 
						'OK'
					);
			
				}
			
			});
		
		} else { //errors
			$('#grocerylistitemnotifymsg').html('Corrections Required');
		}
		
	} else { //not registered
		
		$.mobile.loading( "hide" );
		
		//alert('An account is required to access this functionality. Please go to the home page and login in or Join Us!');
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
			'An account is required to access this functionality. Please go to the home page and login in or Join Us!', 
			alertDismissed,         // callback
			'Alert', 
			'OK'
		);
	}
	
});

//remove item
$(document).on('vclick', '#btngrocerylistremove', function(event, ui) {
	
	var userid = window.localStorage.getItem('userid');
	var serviceskey = window.localStorage.getItem('serviceskey');
	//var itemid = $(this).jqmData('itemid');
	var itemid = $('#btngrocerylistremove').attr('data-itemid');
	
	if (userid > 0) {
	
		$.mobile.loading( "show");
	
		var request = $.ajax({
			type: "POST",
			url: "http://www.grocery-bag.mobi/services/grocerylist_removeitem.v2.php",
			data: { id: userid, itemid: itemid, serviceskey: serviceskey, accesskey: 'qcfkgJw43V]B^Z$M!*(#9A^6%Lr('}, 
			dataType: "json"
		});
		
		request.done(function(data) {
		
			$.mobile.loading( "hide" );
			
			if (data.response == 'error') {
				//alert(data.msg);
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					data.msg, 
					alertDismissed,         // callback
					'Alert', 
					'OK'
				);
				
			} else if (data.response == 'success') {
			
				$.mobile.pageContainer.pagecontainer( "change", "#grocerylist", { reverse: true, transition: "slide" } );
			
			} else {
				//alert( "A Network Error Has Occurred.");
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					'A Network Error Has Occurred.', 
					alertDismissed,         // callback
					'Alert', 
					'OK'
				);
			
			}
			
		});
		
	
	} else { //not registered
		
		$.mobile.loading( "hide" );
		//alert('An account is required to access this functionality. Please go to the home page and login in or Join Us!');
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
			'An account is required to access this functionality. Please go to the home page and login in or Join Us!', 
			alertDismissed,         // callback
			'Alert', 
			'OK'
		);
	}

});


//UTILITIES
function resetitemeditform() {

	itemid = 0;
	$('#grocerylistitemnotifymsg').html('');
	$('#grocerylistitemfrm label').removeClass('notify');
	$('.grocerylistinput').removeClass('invalid');
	$('#grocerylistitemotal').html('0.00');
  		
	$('#grocerylistinputitem').val('');
	$('#grocerylistinputquantity').val('1');
	$('#grocerylistinputnote').val('');
	$('#grocerylistinputprice').val('0.00');
	$('#grocerylistitemid').val('0');
	
	$('#btnprocessgrocerylistitem').html('Add Item');
	$('#btngrocerylistremove').attr('data-itemid', '');
	$('#grocerylistremovebucket').hide();
	
}

function fmtPrice(value) {
	var cents=100*(value-Math.floor(value))+0.5;
	if (cents >= 100) {cents = 0; value += 1;}
	result=Math.floor(value)+".";
	result += Math.floor(cents/10);
	result += Math.floor(cents%10);
	return result;
}
		
function IsNumeric(sText) {
	var ValidChars = "0123456789.";
	var IsNumber=true;
	var Char;
 
	for (i = 0; i < sText.length && IsNumber == true; i++) { 
		Char = sText.charAt(i); 
		if (ValidChars.indexOf(Char) == -1) {
			IsNumber = false;
		}
	}
	return IsNumber;
}

function calculatePriceTotal() {
	var total = 0;
			
	$('li.gl_itembucket').each(function(index) {
    	//console.log($('span.gl_itemqty', this));
    	
    	var qty = $('span.gl_itemqty', this).html();
    	var price = $('span.gl_itemprice', this).html();
    	if (IsNumeric(qty) && IsNumeric(price)) {
    		total = (total + (qty * price));
    	}
	});
			
	total = fmtPrice(total);
	$('#grocerylisttotal').html('Total: '+total);
}

$(document).on( "keyup", "#grocerylistinputquantity", function(e) {

	var $th = $(this);
    var qty = $th.val().replace(/[^0-9]/g, '' );
    $th.val(qty);
    calculateitemtotal();
	
});

$(document).on( "keyup", "#grocerylistinputprice", function(e) {
	
	var $th = $(this);
    var price = $th.val().replace(/[^0-9.]/g, '' );
    $th.val(price);
    calculateitemtotal();
		
});

function calculateitemtotal() {

	var total = fmtPrice($('#grocerylistinputquantity').val() * $('#grocerylistinputprice').val());
	$('#grocerylistitemotal').html(total);

}

