//locations
var map;
var markersArray = [];
//var infowindow;
var marker, i;
var blnMarkerExist = false;

$(document).on("pagebeforeshow", "#locations", function () {
	$('#map_canvas').empty();
});

$(document).on("pageshow", "#locations", function () {
	$.mobile.loading( "show", {
		text: "Loading Locations",
		textVisible: false, 
		theme: "b"
	});
	navigator.geolocation.getCurrentPosition(geo_success_location, geo_error_location);
});

function buildstorelist(initializegooglemap) {
		
	map = '';
	var request = $.ajax({
		type: "POST",
		url: "http://www.grocery-bag.mobi/services/storelist.v2.php",
		data: { groupid: groupid, serviceskey:'mJ8x2_?5020O42-Bd1J-4YJJ8wfUcx_Rr-FL4Vy6_xHXf6_620877VQ;Xwhp_J0Rd'}, 
		dataType: "json"
	});
		
	request.done(function(data) {	
					
		if (data.response == 'error') {
			//alert(data.msg);
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				data.msg, 
				alertDismissed,         // callback
				'Alert', 
				'OK'
			);
		
		} else if (data.response == 'success') {
				
			$('#storestates').removeData();
			$('#storeaddresses').removeData();
				
			$.each(data.states, function(i, statename){
				$('#storestates').data('state'+i, statename);
			});
				
			$.each(data.stores, function(i, store){
				$('#storeaddresses').data('store'+store.id, {id: store.id, site_id: store.site_id, storenum: store.storenum, name: store.name, address01: store.address01, city: store.city, state: store.state, postalcode: store.postalcode, phone: store.phone, emailcontactform: store.emailcontactform, lat: store.lat, lng: store.lng, region: store.region, hours: store.hours, adtype_txt: store.adtype_txt, adtype_jpg: store.adtype_jpg, site_url: store.site_url});
			});
			
			//if (initializegooglemap) initializemap();
			$.mobile.loading( "hide" );
			initializemap();
			printLatLong(window.localStorage.getItem('userlat'), window.localStorage.getItem('userlng'));
			
			//$('#locationpopup a').removeClass('ui-btn-active');
			//$('#locationpopup a').removeClass('ui-btn:hover');
			
		} else {
			//alert( "Login Failed Due To A Network Error.");
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				'Login Failed Due To A Network Error.', 
				alertDismissed,         // callback
				'Alert', 
				'OK'
			);
			
		}
			
	});
 
	request.fail(function(jqXHR, textStatus) {
		//alert( "Login Failed Due To A Network Error."+textStatus);
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
			'Login Failed Due To A Network Error. '+textStatus, 
			alertDismissed,         // callback
			'Login Failure', 
			'OK'
		);
		
	});
	
}

function initializemap() {

	var myOptions = {
		mapTypeId: google.maps.MapTypeId.ROADMAP
	}
	
	map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
	
	var markeruser = {
		url: 'img/marker-user.png',
		size: new google.maps.Size(32.0, 37.0),
		origin: new google.maps.Point(0, 0),
		anchor: new google.maps.Point(13.0, 17.0),
	};
	
	var markerstore = {
		url: 'img/marker-store.png',
		size: new google.maps.Size(32.0, 37.0),
		origin: new google.maps.Point(0, 0),
		anchor: new google.maps.Point(13.0, 17.0),
	};
	
	$.each($('#storeaddresses').data(), function(i, e){
		addmarkers(e.id, e.name, e.lat, e.lng, 'marker-store', i);
	});
	
	map.fitBounds(getBoundsForLatLngs());
	
	/*
	if (window.localStorage.getItem('mystore') <= 0) {
		//alert('You do not have a "My Store" selected. Simply tap on the store marker closest to you and choose make this my store.');
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
			'You do not have a "My Store" selected. Simply tap on the store marker closest to you and choose make this my store.', 
			alertDismissed,         // callback
			'Alert', 
			'OK'
		);
		
	}
	*/
	
}

function addmarkers(id, storename, lat, lng, markertype, i) {
	
    var marker = new google.maps.Marker({
				position: new google.maps.LatLng(lat, lng),
				map: map, 
				icon: 'img/'+markertype+'.png'
	});
			
	markersArray[id] = marker;
	
	google.maps.event.addListener(marker, 'click', function() {
			
		map.panTo(marker.getPosition());
		map.setZoom(8);
		
		if (markertype != 'markeruser') {
			var citystatezip = $('#storeaddresses').data('store'+id).city+', '+$('#storeaddresses').data('store'+id).state+' '+$('#storeaddresses').data('store'+id).postalcode;
			
			$('#site_url').html($('#storeaddresses').data('store'+id).site_url);
			$('#locstorename').html($('#storeaddresses').data('store'+id).name);
			$('#locaddress').html($('#storeaddresses').data('store'+id).address01);
			$('#loccitystatezip').html(citystatezip);
			$('#locdisplayphone').html($('#storeaddresses').data('store'+id).phone);
			$('#locphone').attr('href', 'tel:'+$('#storeaddresses').data('store'+id).phone);
			
			var hours = $('#storeaddresses').data('store'+id).hours;
			if (hours.length > 0) {
				
				hours = hours.replace( /&lt;/g, '<' );
				hours = hours.replace( /&gt;/g, '>' );
				
				$('#lochours').show();
				$('#lochours').html(hours);
				
			} else {
				$('#lochours').hide();
			}
			
			$('#btnmakethismystore').attr('data-storeid', id);
			$('#locationpopup').popup('open');
			
		}
		
	});
	
}

function getBoundsForLatLngs() {
	var bounds = new google.maps.LatLngBounds();
	
	var userlat = window.localStorage.getItem('userlat');
	var userlng = window.localStorage.getItem('userlng');
	
	$.each($('#storeaddresses').data(),function(i, e) {
		bounds.extend(new google.maps.LatLng(e.lat, e.lng));
	});
	
	if (userlat != 0 && userlng != 0) {
		bounds.extend(new google.maps.LatLng(userlat, userlng));
	}
	
	return bounds;
}

// output lat and long
function printLatLong(lat, lng) {

	var id = window.localStorage.getItem('id');
	
	blnMarkerExist = true;
	addmarkers(id, 'user', lat, lng, 'marker-user', 'user'+id);
	
	map.fitBounds(getBoundsForLatLngs());

}

function geo_success_location(position) {
	window.localStorage.setItem('userlat', position.coords.latitude);
	window.localStorage.setItem('userlng', position.coords.longitude);
	initializegooglemap = true;
	buildstorelist(initializegooglemap);
}

function geo_error_location(err) {
	window.localStorage.setItem('userlat', 0);
	window.localStorage.setItem('userlng', 0);
	initializegooglemap = true;
	buildstorelist(initializegooglemap);
}

$(document).on("vclick", "#btnmakethismystore", function (event) {
	event.preventDefault();
	
	var id = $(this).attr('data-storeid');
	var siteid = $('#storeaddresses').data('store'+id).site_id;
	var storeid = $(this).attr('data-storeid');
	var store_lat = $('#storeaddresses').data('store'+id).lat;
	var store_long = $('#storeaddresses').data('store'+id).lng;
	var store_adtype_txt = $('#storeaddresses').data('store'+id).adtype_txt;
	var store_adtype_jpg = $('#storeaddresses').data('store'+id).adtype_jpg;
	
	window.localStorage.setItem('mysite', siteid);
	window.localStorage.setItem('mystore', storeid);
	window.localStorage.setItem('store_lat', store_lat);
	window.localStorage.setItem('store_long', store_long);
	window.localStorage.setItem('store_adtype_txt', store_adtype_txt);
	window.localStorage.setItem('store_adtype_jpg', store_adtype_jpg);
	
	if (window.localStorage.getItem('accountstatus') == 'active') {
		locationupdatemystore(siteid, storeid);
	} else {
	
		//alert('Your store has been update successfully!.');
		
		navigator.notification.alert(
				'Your store has been update successfully!.', 
				alertDismissed,         // callback
				'Alert', 
				'OK'
		);
	
	}

});


function locationupdatemystore(siteid, storeid) {

	var id = (window.localStorage.getItem('userid') !== null) ? window.localStorage.getItem('userid') : 0 ;
	var serviceskey = (window.localStorage.getItem('serviceskey') !== null) ? window.localStorage.getItem('serviceskey') : 0 ;
		
	var request = $.ajax({
		type: "POST",
		url: "http://www.grocery-bag.mobi/services/setmystoreid.v2.php",
		data: { id: id, groupid: groupid, siteid: siteid, storeid: storeid, serviceskey: serviceskey, accesskey: 'g8CmZR-H39AwvF6G7PJQs-hScqzdT'}, 
		dataType: "json"
	});
		
	request.done(function(data) {
		
		if (data.response == 'error') {
				
			//alert(data.msg);
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				data.msg, 
				alertDismissed,         // callback
				'Alert', 
				'OK'
			);
			
			
		} else if (data.response == 'success') {
				
			//alert('Your store has been update successfully!.');
			
			navigator.notification.alert(
				'Your store has been update successfully!.', 
				alertDismissed,         // callback
				'Alert', 
				'OK'
			);
			
			
		} else {
				
			//alert( "Login Failed Due To A Network Error.");
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				'Login Failed Due To A Network Error.', 
				alertDismissed,         // callback
				'Alert', 
				'OK'
			);
		
		}
		
	});
	
	request.fail(function(jqXHR, textStatus) {
		//alert( 'Locations Services Failed Due To A Network Error.'+textStatus);
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
			'Locations Services Failed Due To A Network Error. '+textStatus, 
			alertDismissed,         // callback
			'Login Failure', 
			'OK'
		);
		
	});
	
	
} /*locationupdatemystore*/



