$(document).on("pagebeforeshow", "#weeklyadstext", function (event, ui) {
	
	if (ui.prevPage.attr('id') == 'home') {
		$('#adstextbucket').hide().empty();
		$('#adstexteffectivedate').html('&nbsp;');
		$('#adstextmsg').empty().hide();
		$('#textadsnav').empty();
		$('#textaddata').removeData();
		$('#textaditems').removeData();
		digitaladpage = 0;
	}
		
});
	
$(document).on("pageshow", "#weeklyadstext", function (event, ui) {

	var site_id = (window.localStorage.getItem('mysite') !== null) ? window.localStorage.getItem('mysite') : 0 ;
	var store_id = (window.localStorage.getItem('mystore') !== null) ? window.localStorage.getItem('mystore') : 0 ;
	
	if (site_id > 0 && store_id > 0 && ui.prevPage.attr('id') == 'home') {
	
		var request = $.ajax({
			type: "POST",
			url: "http://www.grocery-bag.mobi/services/weeklyads_textnavmenu.v2.php",
			data: { site_id: site_id, store_id: store_id,  accesskey: 'N-6ZePh-U28Ma-g-dREn4V-EkE-nu'}, 
			dataType: "json"
		});
		
		request.done(function(data) {
			
			if (data.response == 'error') {
				//alert(data.msg);
				
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					data.msg, 
					alertDismissed,         // callback
					'Alert', 
					'OK' 
				);
				
			} else if (data.response == 'success' && data.msg) {
				//NO AD THIS WEEK
				$.mobile.loading( "hide" );
				$('#adstextmsg').append('<h4 class="centertext">'+data.msg+'</h4>').show();
				
			} else if (data.response == 'success' && data.pages) {
				
				var listitems = '';
				var curraddates = '';
				var lastpage = data.pages.length-1;
				
				//BUILD MENU
				$.each(data.pages, function(i, e) {
				
					addates = e.startdtF+' - '+e.enddtF;
					if (curraddates != addates) {
						listitems = listitems+'<li data-autodividers="true">'+addates+'</li>\n';
						curraddates = addates;
					}
					
					listitems = listitems+'<li><a href="#" data-adid="'+i+'" class="changeadpage">Page '+e.page+'</a></li>\n';
					$('#textaddata').data('adid'+i, {page: e.page, startdt: e.startdt, enddt: e.enddt, displaydates: addates});
				
				});
				
				$('#textadsnav').append(listitems);
				$('#textadsnav').listview('refresh');
				loadadadtext(digitaladpage);
			
			} else {
				//alert( "A Network Error Has Occurred.");
				
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					'A Network Error Has Occurred.', 
					alertDismissed,         // callback
					'Alert', 
					'OK' 
				);
				
			
			}
			
		});
	
	} else if (ui.prevPage.attr('id') == 'home') { //missing store selection
		
		//alert('A store location is required to access this functionality.');
		navigator.notification.vibrate(1000);
		navigator.notification.alert(
					'A store location is required to access this functionality.', 
					alertDismissed,         // callback
					'Alert', 
					'OK' 
		);
		
		startgeolocation();
		
	}
	
});

//selected page functions
$(document).on('vclick', '.changeadpage', function(event, ui) {
	event.preventDefault();
	$("#navweeklyadspages").popup( "close" );
	$('#adstextbucket').hide().empty();
	var i = $(this).jqmData('adid');
	digitaladpage = i;
	loadadadtext(i);
});

$(document).on("vclick", ".previousLinkAdsTxt", function (event) {
	event.preventDefault();
	$('#adstextbucket').hide().empty();
	var i = $(this).attr('data-adid');
	digitaladpage = i;
	loadadadtext(i);

});

$(document).on("vclick", ".nextLinkAdsTxt", function (event) {
	event.preventDefault();
	$('#adstextbucket').hide().empty();
	console.log($(this));
	var i = $(this).attr('data-adid');
	digitaladpage = i;
	loadadadtext(i);
});


//selected item details
$(document).on('vclick', '.itemdetails', function(event, ui) {
    
    event.preventDefault();
    
    var itemid = $(this).attr('id');
    	
	var item = $('#textaditems').data(itemid).brand;
	if ($('#textaditems').data(itemid).descript != null) item = item + ' '+$('#textaditems').data(itemid).descript;
	if ($('#textaditems').data(itemid).descript02 != null) item = item + ' '+$('#textaditems').data(itemid).descript02;
	
	
	if ($('#textaditems').data(itemid).image) {
		var itemimage = '<img src="http://www.'+$('#textaditems').data(itemid).site_url+'/circulars_txtimages/'+$('#textaditems').data(itemid).startdt+'/'+$('#textaditems').data(itemid).image+'">';
    } else {
		var itemimage = '<img src="http://www.'+$('#textaditems').data(itemid).site_url+'/images/missing_image.jpg">';
	}
	
	$('#itemdetails_prod').html(item);
	$('#itemdetails_image').html(itemimage);
	$('#itemdetails_size').html($('#textaditems').data(itemid).size);
	$('#itemdetails_price').html($('#textaditems').data(itemid).price);
	
	if  ($('#textaditems').data(itemid).recipeid > 0) {
		$('#itemdetails_recipe').html('Recipe: '+$('#textaditems').data(itemid).recipename);
	}
	
	$('#btnitemdetails_addtoGL').attr('data-productid', $('#textaditems').data(itemid).product_id);
	if  ($('#textaditems').data(itemid).recipeid == 0) {
		$('#btnitemdetails_viewrecipe').hide();
	} else {
		$('#btnitemdetails_viewrecipe').show();
		$('#btnitemdetails_viewrecipe').attr('data-recipeid', $('#textaditems').data(itemid).recipeid);
	}
	
	$.mobile.pageContainer.pagecontainer( "change", "#weeklyadsitemdetails", { transition: "slide" } );
    	
});

$(document).on('vclick', '#btnitemdetails_viewrecipe', function(event) {
	
	event.preventDefault();
	displayrecipe = $(this).attr('data-recipeid');
	
	$.mobile.pageContainer.pagecontainer('change', '#recipedetails', {
		transition: 'slide',
        changeHash: true,
        reverse: false
	});
	
    return false;  

});

/*
$(document).on("popupafterclose", "#popupitemdetails", function (event, ui) {
	$('#itemdetails_prod').html('');
	$('#itemdetails_size').html('');
	$('#itemdetails_price').html('');
	$('#itemdetails_recipe').html('');
	$('#btnitemdetails_addtoGL').show();
});
*/

//Add item to grocery list
$(document).on('vclick', '#btnitemdetails_addtoGL', function(event, ui) {
	
	event.preventDefault();
	
	if (window.localStorage.getItem('accountstatus') == 'active' && window.localStorage.getItem('userid') > 0) {
 
		var userid = window.localStorage.getItem('userid');
		var product_id = $(this).attr('data-productid');
		var serviceskey = window.localStorage.getItem('serviceskey');
		$('#glitemaddednotify').remove();
			
		var request = $.ajax({
				type: "POST",
				url: "http://www.grocery-bag.mobi/services/weeklyads_addtogrocerylist.v2.php",
				data: { product_id: product_id, 'userid': userid, 'serviceskey': serviceskey, accesskey: 'jr6s-hsyejkd2FarY-irkY6-ke2ujdi7-75'}, 
				dataType: "json"
		});
			
		request.done(function(data) {
			
			if (data.response == 'error') {
				//alert(data.msg);
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					data.msg, 
					alertDismissed,         // callback
					'Alert', 
					'OK' 
				);
				
					
			} else if (data.response == 'success') {
					
				$('#itemdetails_prod').prepend(' <div id="glitemaddednotify" class="notify">Item Added</div>');
					
			} else {
				//alert( "A Network Error Has Occurred-.");
				
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					'A Network Error Has Occurred-.', 
					alertDismissed,         // callback
					'Alert', 
					'OK' 
				);
				
			}
				
		});
	
	} else {
		
		navigator.notification.vibrate(1000);
		navigator.notification.confirm(
			'An account is required to access this functionality. Please Sign In or Join Us!', // message
			alertDismissedAccount,         // callback
			'Account Status Alert',		// title
			'Sign In, Join Us, Continue As Guest'                  	// buttonName
		);
	
	}
	
		
});

//load page text
function loadadadtext(i) {
	
	$.mobile.loading( "show", {
		text: "Loading Digital Ads",
		textVisible: false, 
		theme: "b"
	});
	
	var displaydates = $('#textaddata').data('adid'+i).displaydates;
	var page = $('#textaddata').data('adid'+i).page;
	var startdt = $('#textaddata').data('adid'+i).startdt;
	var enddt = $('#textaddata').data('adid'+i).enddt;
	var pagecount = $('#textadsnav li a.changeadpage').length-1;
	setadprevbtn(i, pagecount);
	setadnextbtn(i, pagecount);
	
	$('#adstexteffectivedate').html(displaydates);

	var site_id = (window.localStorage.getItem('mysite') !== null) ? window.localStorage.getItem('mysite') : 0 ;
	var store_id = (window.localStorage.getItem('mystore') !== null) ? window.localStorage.getItem('mystore') : 0 ;
	
	var request = $.ajax({
		type: "POST",
		url: "http://www.grocery-bag.mobi/services/weeklyads_text.v2.php",
		data: { site_id: site_id, store_id: store_id, page: page, startdt: startdt, enddt: enddt, accesskey: 'smQ-zCECP2FarY-adY6-jnuft7F-76'}, 
		dataType: "json"
	});
		
	request.done(function(data) {
		
		if (data.response == 'error') {
				
				$.mobile.loading( "hide" );
				//alert(data.msg);
				
				navigator.notification.vibrate(1000);
				navigator.notification.alert(
					data.msg, 
					alertDismissed,         // callback
					'Alert', 
					'OK' 
				);
				
		} else if (data.response == 'success' && data.msg) {
				
				$.mobile.loading( "hide" );
				$('#adstextmsg').append('<h4 class="centertext">'+data.msg+'</h4>').show();
				
		} else if (data.response == 'success' && data.items) {
			
    			var currdept = '';
    			var items = '';
			
				$.each(data.items, function(i, e) {
				
					if (currdept != e.department_name) {
						items = items+'<li data-role="list-divider">'+e.department_name+'</li>';
						currdept = e.department_name;
					}
					
					items = items+'<li data-icon="info">' + 
									'<a href="#" data-itemid="'+e.product_id+'" id="item'+e.product_id+'" class="itemdetails">';
									if (e.image) {
        								items = items+'<img src="http://www.'+e.site_url+'/circulars_txtimages/'+startdt+'/'+e.image+'" class="thumbnailverticalcenter">';
        							} else {
        								items = items+'<img src="http://www.'+e.site_url+'/images/missing_image.jpg" class="thumbnailverticalcenter">';
        							}
        		items = items+'<h2>'+$.trim(e.brand);
        			
        		if (e.descript.length !== 0) {
        			items = items+'<br />'+$.trim(e.descript);
        		}
        			
        		items = items+'<br />'+$.trim(e.price)+
        						'</h2>'+
        						'</a>'+
								'</li>';
									
				$('#textaditems').data('item'+e.product_id, {product_id: e.product_id, dept_id: e.dept_id, page: e.page, brand: e.brand, descript: e.descript, descript02: e.descript02, size: e.size, price: e.price, recipename: e.recipename, recipeid: e.recipeid, image: e.image, department_name: e.department_name, site_url: e.site_url, startdt: startdt});
					
			});

			$('#adstextbucket').append(items);
			$('#adstextbucket').listview('refresh').show();
			$.mobile.loading( "hide" );
				
		} else {
			$.mobile.loading( "hide" );
			//alert( "A Network Error Has Occurred-.");
			navigator.notification.vibrate(1000);
			navigator.notification.alert(
				'A Network Error Has Occurred-.', 
				alertDismissed,         // callback
				'Alert', 
				'OK' 
			);
				
		}
			
	});
	
}

function setadprevbtn(i, pagecount) {
	if (i == 0) {
		$('.previousLinkAdsTxt').attr('data-adid', pagecount);
	} else {
		var prevpage = parseInt(i)-1;
		$('.previousLinkAdsTxt').attr('data-adid', prevpage);
	}
}

function setadnextbtn(i, pagecount) {
	
	if (i == pagecount) {
		$('.nextLinkAdsTxt').attr('data-adid', '0');
	} else {
		var nextpage = parseInt(i)+1;
		$('.nextLinkAdsTxt').attr('data-adid', nextpage);
	}
	
}











